#include <X11/copyright.h>

/* $XConsortium: SignalP.h,v 1.4 89/07/21 01:41:48 kit Exp $ */
/* Copyright	Massachusetts Institute of Technology	1987, 1988 */

#ifndef _SignalP_h
#define _SignalP_h

#include "Signal.h"
/* include superclass private header file */
#include <X11/Xaw/SimpleP.h>

/* define unique representation types not found in <X11/StringDefs.h> */

#define XtRSignalResource "SignalResource"

typedef struct {
    int empty;
} SignalClassPart;

typedef struct _SignalClassRec {
    CoreClassPart	core_class;
    SimpleClassPart	simple_class;
    SignalClassPart	signal_class;
} SignalClassRec;

extern SignalClassRec signalClassRec;

typedef struct {
    /* resources */
    int time_scale;
    int *sample;
    int sample_length;
    int levels;
    int origin;
    int internal_height;
    int max_sample_length;
    Pixel foreground;
    Boolean editable;
    XtCallbackList edit_callback;
    int time_division;
    /* private state */
    XPoint *points;
    int npoints;
    GC gc, xor_gc, gc_div;
    int spacing;
    int sel_start, sel_end;
} SignalPart;

typedef struct _SignalRec {
    CorePart	core;
    SimplePart	simple;
    SignalPart	signal;
} SignalRec;

#endif /* _SignalP_h */
